import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { Type } from "igniteui-react-core/ES2015/type";
import { IFastItemColumn$1 } from "igniteui-react-core/ES2015/IFastItemColumn$1";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasHighLowValueCategory } from "./IHasHighLowValueCategory";
import { RangeCategoryFramePreparer } from "./RangeCategoryFramePreparer";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { List$1 } from "igniteui-react-core/ES2015/List$1";
import { Polyline } from "igniteui-react-core/ES2015/Polyline";
import { Polygon } from "igniteui-react-core/ES2015/Polygon";
import { Rect } from "igniteui-react-core/ES2015/Rect";
import { Axis } from "./Axis";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-react-core/ES2015/FastItemsSourceEventAction";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderSurface } from "./RenderSurface";
/**
 * @hidden
 */
export declare class RangeCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    j: RangeCategorySeriesView;
    constructor(a: RangeCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private l;
    private k;
    private i;
    private h;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class RangeCategorySeries extends CategorySeries implements IIsCategoryBased, IHasHighLowValueCategory {
    static $t: Type;
    protected bf(): SeriesView;
    getHostReferenceValue(): number;
    im(a: SeriesView): void;
    oq: RangeCategorySeriesView;
    constructor();
    private _RangeFramePreparer;
    RangeFramePreparer: RangeCategoryFramePreparer;
    oz: string;
    lowColumn: IFastItemColumn$1<number>;
    private ot;
    ow: string;
    highColumn: IFastItemColumn$1<number>;
    private or;
    protected m9(): CategoryTransitionInMode;
    oh(a: CategoryFrame, b: CategorySeriesView): void;
    protected o1(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    c8(a: any): boolean;
    protected is(a: any, b: string, c: any, d: any): void;
    an(a: Axis): AxisRange;
    protected hs(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    dv(a: Rect, b: Rect, c: SeriesView): boolean;
    oe(a: CategoryFrame, b: CategorySeriesView): void;
    readonly currentCategoryMode: CategoryMode;
    readonly scaler: ICategoryScaler;
    readonly yScaler: IScaler;
    readonly bucketizer: IBucketizer;
    readonly currentMode2Index: number;
    provideCollisionDetector(): IDetectsCollisions;
    readonly mayContainUnknowns: boolean;
    i8(a: Rect, b: RenderSurface): void;
    private oo;
    i5(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    ee(): number;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class RangeCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    cw: RangeCategorySeries;
    constructor(a: RangeCategorySeries);
    cx(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    co(): CategoryBucketCalculator;
}
